

     BIGB(ADM)               - Additional command -

     Name
          bigb - checks for possible breakins

     Syntax
          /usr/bin/bigb

     Description
      This program should be started in the after booting usually
      by means of an entry in the /etc/rc.d/8/userdef file. It
      will initially announce itself and put itself in the background.
          It checks the protected password and terminal entries at a
          specified interval and reports any suspicious activity to
          the console and a log file.
            The events regarded as suspicious are:
              1 ) More than a specified number of consecutive login
                    failures on the same account.
              2 ) More than a specified number of consecutive login
                    failures on the same terminal.
              3 ) Root logging it - or attempting to log in.

          The number of events after which warnings should be given
          can be specified as can a list of accounts/terminals to be
          checked or not checked on an individual basis. The root
          account is treated specially and will usually generate
          warnings on any login attempt.

          The program takes no parameters but reads data from a
          configuration file to be found in /etc/default/bigb.  
          This configuration file consists of entries of the form
            parameter=value
          The parameters available and their default settings are:

            terminalfaults=3
                - Warn after this number of consecutive failures
                - If negative then do not check terminals
            userfaults=3
                - Warn after this number of consecutive failures
                - If negative then do not check users
            checkroot=yes
                - Warn of any root activity (logins)
                - This parameter can only be 'yes' or 'no'
            sleeptime=10
                - Do checks every 10 seconds
            nicevalue=0
                - Run at nice(0)
            errorfile=/usr/adm/warnings
                - Append copies of all warning to this file
                - A null value ( nothing after the = ) means
                - send warnings to stdout
            errorout=/dev/console
                - Send <BLEEP> WARNING: message to this 'file'
                - See errorfile for a description of null entries
            badterms=/usr/lib/bigb/check_term
                - Check these terminals
            goodterms=/usr/lib/bigb/nocheck_term
                - Do not check these terminals
            badusers=/usr/lib/bigb/check_user
                - Check these users
            goodusers=/usr/lib/bigb/nocheck_user
                - Do not check these users

          The program only checks the configuration file when it starts
          but after recieving a SIGHUP ( as sent by kill -1 ) it rechecks
          the file and continues using the new parameters. Beware of
          this increasing the nice value of the process.

          NOTE: To check all users/terminals the easiest arrangement
          is to have null nocheck_user and nocheck_term files.

     Files
          /etc/default/bigb            Configuration file

          /usr/adm/warnings            Default log file of all warnings

          /usr/lib/bigb/check_term     Default list of terminals to check

          /usr/lib/bigb/nocheck_term   Default list of terminals not to check

          /usr/lib/bigb/check_user     Default list of users to check

          /usr/lib/bigb/nocheck_user   Default list of users not to check

     Bugs
          There is only one known bug - due to the difficulty of finding out
          which terminal a login failure was made on it is derived from the
          datestamp of the terminal.  This is not totally reliable so sometimes
          it will give up and say 'unknown terminal'.

     History
          Written August 1991 by Matthew Paley - mtp@uk.ac.ukc
