/* Check to see if root has logged on - or attempted to */

#include "bigb.h"

PUBLIC void check_root(void)
{
    int                 succ;       /* Successful? */
    struct pr_passwd    *user;
    struct pr_field     *data;
    time_t              last_used;

    /* If checking of root is disabled then return */
    if (!check_root_selected)
        return;

    /* Get data on root - check for failure though that should never happen */
    if ((user=getprpwnam("root")) == (struct pr_passwd *) NULL) {
        /* Should do something here, but what! */
        return;
    }
    endprpwent();

    data  = &(user->ufld);

    /* A TRUE/FALSE flag for successful/failed login */
    succ = (data->fd_slogin > data->fd_ulogin)? TRUE:FALSE;

    /* Time the root account was last used */
    last_used = (succ == TRUE)? data->fd_slogin : data->fd_ulogin;
        
    if (last_checked > last_used)
        return;     /* Not used since last check */
    
    /* Generate the warning message and print it */
    sprintf(temp, "%s: root has %s onto %s",
        date(last_used),
        (succ == TRUE)? "successfully logged":"failed to log",
        find_relevant_terminal(succ,data->fd_uid,last_used));
    print_warning(temp);
}
